VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "DocumentGraphicInformation"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Member0" ,"GraphicInstances"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit
' This class is a container for the GraphicInstances collection object.
'
' Public Properties:
'   GraphicInstances: This returns a GraphicInstances collection.
'
' Public Methods:
'   GetGraphicInformation, populates a GraphicInstances collection.
'   PARAMETERS:
'       WordDocument: The document being checked for graphics.
'       LinkedOnly: If TRUE only linked graphics are added to the collection, else
'       all graphics are added.

Private mvarGraphicInstances As GraphicInstances
Public Enum GraphicType
    typShape = 1
    typInlineShape = 2
End Enum


Public Property Get GraphicInstances() As GraphicInstances

    If mvarGraphicInstances Is Nothing Then
        Set mvarGraphicInstances = New GraphicInstances
    End If

    Set GraphicInstances = mvarGraphicInstances

End Property

Public Property Set GraphicInstances(vData As GraphicInstances)
    
    Set mvarGraphicInstances = vData

End Property

Private Sub Class_Terminate()
    
    Set mvarGraphicInstances = Nothing

End Sub

' PARAMETERS:
' WordDocument: the document being checked for graphics
' LinkedOnly: if TRUE only linked graphics are added to the collection, else
' all graphics are added.
Public Sub GetGraphicInformation(WordDocument As Document, LinkedOnly As Boolean)
    
    Dim shpCurrent As Word.Shape
    Dim ilsCurrent As Word.InlineShape
    Dim intCounter As Integer 'This is a counter in a For Next loop.
    Dim intPosition As Integer 'This stores the number of Shapes in the document.
    Dim rngTemp As Word.Range
    Dim varGraphicsArray() As Variant 'This is an array that stores the information about the graphics.
    Dim intStatusCounter As Integer 'This is used to increment the progress bar.
    
    On Error GoTo ErrHandler
    If WordDocument.Shapes.Count + WordDocument.InlineShapes.Count = 0 Then
        Exit Sub
    End If
    Set mvarGraphicInstances = New GraphicInstances
    
    ' Sets the status bar based on the Shape and InlineShape counts.
'    frmWizard.prbStatus.Max = 2 * (WordDocument.Shapes.Count + WordDocument.InlineShapes.Count)
'    intStatusCounter = 0
        
'Array positions:
' 1 = 1, Shape or 2, InlineShape
' 2 = Shape type
' 3 = SubType (for shape objects)
' 4 = Start position in document
' 5 = End position in document
' 6 = Linked object source path
' 7 = OLE Class type (for inline shapes)
' 8 = Hyperlink target address

    If WordDocument.Shapes.Count > 0 Then
    
        ' Create an array based on the number of Shapes in the document.
        ReDim varGraphicsArray(1 To 8, 1 To WordDocument.Shapes.Count)
        
        ' Loop through all of the Shape objects in the document.
        For intCounter = 1 To WordDocument.Shapes.Count
            ' Increment the status counter.
'            intStatusCounter = intCounter
'            With frmWizard
'                .prbStatus.Value = intStatusCounter
'                .Refresh
'            End With
            
            Set shpCurrent = WordDocument.Shapes(intCounter)
            
            ' If the Shape object is valid then adds it to the array.
            If LinkedOnly And Not shpCurrent.LinkFormat Is Nothing Or _
                LinkedOnly = False Then
                
                ' Populate the array with information about the Shape object.
                varGraphicsArray(1, intCounter) = typShape
                varGraphicsArray(2, intCounter) = shpCurrent.Type
                
                If shpCurrent.Type = msoAutoShape Then
                    varGraphicsArray(3, intCounter) = shpCurrent.AutoShapeType
                Else
                    varGraphicsArray(3, intCounter) = Empty
                End If
                
                varGraphicsArray(4, intCounter) = shpCurrent.Anchor.Start
                varGraphicsArray(5, intCounter) = shpCurrent.Anchor.End
                
                If Not shpCurrent.LinkFormat Is Nothing Then
                    varGraphicsArray(6, intCounter) = shpCurrent.LinkFormat.SourceFullName
                Else
                    varGraphicsArray(6, intCounter) = Empty
                End If
                
                If Not shpCurrent.OLEFormat Is Nothing Then
                    varGraphicsArray(7, intCounter) = shpCurrent.OLEFormat.ClassType
                Else
                    varGraphicsArray(7, intCounter) = Empty
                End If
                
                If shpCurrent.Hyperlink Is Nothing Then
                    varGraphicsArray(8, intCounter) = shpCurrent.Hyperlink.Address
                Else
                    varGraphicsArray(8, intCounter) = Empty
                End If
            End If
            
        Next intCounter
    End If
    
    intPosition = WordDocument.Shapes.Count
    
    
    If WordDocument.InlineShapes.Count > 0 Then
    
        ' Redimension the array for the InlineShape objects
        ' and preserve the Shape objects in the array.
        ReDim Preserve varGraphicsArray(1 To 8, 1 To intPosition + WordDocument.InlineShapes.Count)
        
        ' Loop through all of the InlineShapes in the document.
        For intCounter = 1 To WordDocument.InlineShapes.Count
            
            ' Increment the status bar.
'            intStatusCounter = intStatusCounter + 1
'            With frmWizard
'                .prbStatus.Value = intStatusCounter
'                .Refresh
'            End With
            Set ilsCurrent = WordDocument.InlineShapes(intCounter)
            
            ' If the InlineShape object is valid, adds it to the array.
            If LinkedOnly And Not ilsCurrent.LinkFormat Is Nothing Or _
                LinkedOnly = False Then
            
                varGraphicsArray(1, intPosition + intCounter) = typInlineShape
                varGraphicsArray(2, intPosition + intCounter) = ilsCurrent.Type
                varGraphicsArray(3, intPosition + intCounter) = Empty
                varGraphicsArray(4, intPosition + intCounter) = ilsCurrent.Range.Start
                varGraphicsArray(5, intPosition + intCounter) = ilsCurrent.Range.End
                If Not ilsCurrent.LinkFormat Is Nothing Then
                    varGraphicsArray(6, intPosition + intCounter) = ilsCurrent.LinkFormat.SourceFullName
                Else
                    varGraphicsArray(6, intPosition + intCounter) = Empty
                End If
                            
                If Not ilsCurrent.OLEFormat Is Nothing Then
                    varGraphicsArray(7, intPosition + intCounter) = ilsCurrent.OLEFormat.ClassType
                Else
                    varGraphicsArray(7, intPosition + intCounter) = Empty
                End If
                
                If Not ilsCurrent.Hyperlink Is Nothing Then
                    varGraphicsArray(8, intPosition + intCounter) = ilsCurrent.Hyperlink.Address
                Else
                    varGraphicsArray(8, intPosition + intCounter) = Empty
                End If
            End If
        Next intCounter
    End If
    
' If the array isn't empty, use Excel to sort it.
If UBound(varGraphicsArray, 2) > 1 Then
    varGraphicsArray = ExcelSort(varOldArray:=varGraphicsArray, intSortField:=4)
ElseIf varGraphicsArray(1, 1) = Empty Then
    Exit Sub
End If

    ' After being sorted sequentially, the array is pushed into a
    ' a GraphicInstances object.
    For intCounter = 1 To UBound(varGraphicsArray, 2)
'        intStatusCounter = intStatusCounter + 1
'        With frmWizard
'            .prbStatus.Value = intStatusCounter
'            .Refresh
'        End With
        ' GraphicInstance objects are added here.
        mvarGraphicInstances.Add WordShapeType:=CInt(varGraphicsArray(1, intCounter)), _
            StartPosition:=CDbl(varGraphicsArray(4, intCounter)), _
            EndPosition:=CDbl(varGraphicsArray(5, intCounter)), _
            GraphicType:=varGraphicsArray(2, intCounter), _
            LinkedPath:=CStr(varGraphicsArray(6, intCounter)), _
            GraphicSubType:=CInt(varGraphicsArray(3, intCounter)), _
            OLEClass:=CStr(varGraphicsArray(7, intCounter)), _
            Target:=CStr(varGraphicsArray(8, intCounter))
    Next intCounter
    
'    With frmWizard
'        .prbStatus.Value = 0
'        .Refresh
'    End With
    
Exit Sub

ErrHandler:
    Select Case Err.Number
        Case 4198
            ' The hyperlink object exists, but returns an error
            ' because it is unpopulated.
            varGraphicsArray(8, intCounter) = Empty
            Resume Next
        Case Else
            MsgBox prompt:="An error occurred", _
                Buttons:=vbOKOnly, _
                Title:="Error!"
            Unload main
            Exit Sub
        
    End Select
    
End Sub

