VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "DocumentStyleInformation"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Member0" ,"StyleInstances"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit
' This class is a container for the StyleInstances collection object.
'
' Public Properties:
'   StyleInstances: Collection, returns StyleInstances collection
'
' Public Methods:
'   GetStyleInformation, populates the StyleInstances collection
'   PARAMETERS:
'       WordDocument: the document being checked for styles
'       IncludeCSS: TRUE if the CSS style information should be included.

Private mvarStyleInstances As StyleInstances

Public Property Get StyleInstances() As StyleInstances
    
    Set StyleInstances = mvarStyleInstances

End Property

Private Sub Class_Initialize()
    
    Set mvarStyleInstances = New StyleInstances

End Sub

Private Sub Class_Terminate()
    
    Set mvarStyleInstances = Nothing

End Sub
' PARAMETERS:
' WordDocument: the document being checked for styles
' IncludeCSS: TRUE if the CSS style information should be included.
Public Sub GetStyleInformation(WordDocument As Document, IncludeCSS As Boolean)
    
    Dim stlCurrent As Word.Style
    Dim intCounter As Integer 'This is a counter for a For Next loop.
    Dim rngTemp As Word.Range
    Dim rngLink As Word.Hyperlink
    Dim varStylesArray() As Variant 'This represents an array of the styles in the document.
    Dim docTemp As New Word.Document
    Dim intStatusCounter As Integer 'This is used to change the value of the progress bar.
    
    Set mvarStyleInstances = New StyleInstances
    
    ' Set the status bar based on the Styles count.
    intStatusCounter = 0
    
    ReDim varStylesArray(1 To 5, 0)
        
    ' Loop through style in the document's Styles collection.
    For Each stlCurrent In WordDocument.Styles
    
        intStatusCounter = intStatusCounter + 1
    
        ' If the style isn't the default style, searches the document
        ' for each instance of the style.
        If stlCurrent <> "Default Paragraph Font" _
            And stlCurrent.Type = wdStyleTypeCharacter _
            And stlCurrent.InUse Then
        
            WordDocument.Range.Select
            WordDocument.Windows(1).Selection.Find.ClearFormatting
                ' The selection object must be fully qualified,
                ' or it will break when another Word document
                ' is open or active.
                With WordDocument.Windows(1).Selection.Find
                    .Style = stlCurrent.NameLocal
                    .Forward = True
                    .Wrap = wdFindStop
                    .Format = True
                    .Execute
                End With
                
                ' Search for an instance of the style.
                If WordDocument.Windows(1).Selection.Find.Found Then
                    If UBound(varStylesArray, 2) > 0 Then
                         ReDim Preserve varStylesArray(1 To 5, UBound(varStylesArray, 2) + 1)
                    End If
                ' Each time an instance of the style is found,
                ' this adds that instance's information to the array.
                ' When there are no more instances, it jumps to the next
                ' style in the collection.
                ' The positions in the array represent:
                ' 1 = Start position of style instance
                ' 2 = End position of style instance
                ' 3 = Style name
                ' 4 = Style type (paragraph = 1, character = 2)
                ' 5 = Hyperlink target
                    Do Until WordDocument.Windows(1).Selection.Find.Found = False
                        varStylesArray(1, UBound(varStylesArray, 2)) = WordDocument.Windows(1).Selection.Range.Start
                        varStylesArray(2, UBound(varStylesArray, 2)) = WordDocument.Windows(1).Selection.Range.End
                        varStylesArray(3, UBound(varStylesArray, 2)) = Replace(Expression:=stlCurrent.NameLocal, Find:=Chr(32), Replace:="")
                        varStylesArray(4, UBound(varStylesArray, 2)) = stlCurrent.Type
                        
                        If stlCurrent.NameLocal = "Hyperlink" Then
                            varStylesArray(5, UBound(varStylesArray, 2)) = WordDocument.Windows(1).Selection.Hyperlinks(1).Address
                        Else
                            varStylesArray(5, UBound(varStylesArray, 2)) = Empty
                        End If
                        
                        Set rngTemp = WordDocument.Windows(1).Selection.Range
                        WordDocument.Windows(1).Selection.Find.Execute

                        If WordDocument.Windows(1).Selection.Start = rngTemp.Start And WordDocument.Windows(1).Selection.End = rngTemp.End Then
                            Exit Do
                        End If
                        If WordDocument.Windows(1).Selection.Find.Found Then
                            ReDim Preserve varStylesArray(1 To 5, UBound(varStylesArray, 2) + 1)
                        End If
                        
                    Loop
                End If
        End If
    Next

' Sort the array using Excel.
If UBound(varStylesArray, 2) > 0 Then
    varStylesArray = ExcelSort(varStylesArray, 1)
ElseIf varStylesArray(1, 0) = Empty Then
    Exit Sub
End If


    ' Walk through the sorted array and add StyleInstance objects to the
    ' StyleInstances collection.
    For intCounter = 0 To UBound(varStylesArray, 2)

        mvarStyleInstances.Add StyleName:=CStr(varStylesArray(3, intCounter)), _
            StartPosition:=CDbl(varStylesArray(1, intCounter)), _
            EndPosition:=CDbl(varStylesArray(2, intCounter)), _
            StyleType:=CInt(varStylesArray(4, intCounter)), _
            Target:=CStr(varStylesArray(5, intCounter))
    Next
End Sub






