VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "GraphicInstances"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"No"
Attribute VB_Ext_KEY = "Collection" ,"GraphicInstance"
Attribute VB_Ext_KEY = "Member0" ,"GraphicInstance"
Option Explicit
' This class stores a collection of GraphicInstance objects.
'
' Public Properties:
'    Item:  GraphicInstance, returns individual GraphicInstance from the collection.
'    Count:  Long, returns count of GraphicInstance objects in the collection.
'
' Public Methods:
'    Add: Adds a new GraphicInstance to the collection, returns GraphicInstance object.
'    PARAMETERS:
'        WordShapeType:  Type of Word shape, 1 = Shape, 2 = InlineShape.
'        StartPostion:  Starting position of the graphic.
'        EndPosition:  Ending position of the graphic.
'        GraphicType:  Type of Shape or InlineShape.
'        LinkedPath:  Source location if graphic is external.
'        OLEClass:  OLE Class type.
'        Target:  URL target address if graphic is a hyperlink.
'        sKey:  Index position of where to place the graphic.
'
' Events:
'    Initialize:  Occurs when the class is created.
'    Terminate: Occurs when the class ends.

Private mCol As Collection

Public Function Add(WordShapeType As Integer, _
    StartPosition As Double, _
    EndPosition As Double, _
    GraphicType As Variant, _
    LinkedPath As String, _
    GraphicSubType As Integer, _
    OLEClass As String, _
    Target As String, _
    Optional sKey As String) As GraphicInstance
    
    'create a new object
    Dim objNewMember As GraphicInstance
    Set objNewMember = New GraphicInstance


    'set the properties passed into the method
    With objNewMember
        .StartPosition = StartPosition
        .EndPosition = EndPosition
        .GraphicType = GraphicType
        .LinkedPath = LinkedPath
        .GraphicSubType = GraphicSubType
        .WordShapeType = WordShapeType
        .OLEClass = OLEClass
        .Target = Target
        .Index = mCol.Count + 1
    End With
    
    If Len(sKey) = 0 Then
        mCol.Add objNewMember
    Else
        mCol.Add objNewMember, sKey
    End If

    'return the object created
    Set Add = objNewMember
    Set objNewMember = Nothing

End Function

Public Property Get Item(vntIndexKey As Variant) As GraphicInstance
Attribute Item.VB_UserMemId = 0
  
  Set Item = mCol(vntIndexKey)

End Property

Public Property Get Count() As Long
    
    Count = mCol.Count

End Property

Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
    
    Set NewEnum = mCol.[_NewEnum]

End Property

Private Sub Class_Initialize()
    
    Set mCol = New Collection

End Sub

Private Sub Class_Terminate()
    
    Set mCol = Nothing

End Sub

