VERSION 5.00
Begin VB.Form main 
   Caption         =   "Convert2XML"
   ClientHeight    =   5610
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   11355
   LinkTopic       =   "main"
   ScaleHeight     =   5610
   ScaleWidth      =   11355
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdClose 
      Caption         =   "Close"
      Height          =   375
      Left            =   9360
      TabIndex        =   4
      Top             =   5040
      Width           =   1575
   End
   Begin VB.TextBox txtError 
      Height          =   3975
      Left            =   360
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   3
      Text            =   "main.frx":0000
      Top             =   840
      Width           =   10575
   End
   Begin VB.CommandButton cmdExecute 
      Caption         =   "Execute"
      Height          =   375
      Left            =   9360
      TabIndex        =   2
      Top             =   240
      Width           =   1575
   End
   Begin VB.TextBox txtControlFile 
      Height          =   315
      Left            =   1440
      TabIndex        =   1
      Text            =   ".\control.xml"
      Top             =   240
      Width           =   7695
   End
   Begin VB.Label Label1 
      Caption         =   "Control File:"
      Height          =   255
      Left            =   360
      TabIndex        =   0
      Top             =   240
      Width           =   975
   End
End
Attribute VB_Name = "main"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Const CONV2XML_VERSION = "1.1"
Private Const DEFAULT_CONTROLFILE = "Control Files\control.xml"

Public Enum LogMessageType
    StatusMessage
    WarningMessage
    ErrorMessage
End Enum

Public Enum DataSourceType
    ADO
    MSExcel
    SQLServer
    ORACLE
    MSWord
End Enum

Private Sub ClearLog()

    On Error GoTo ErrHandler
    
    txtError.Text = ""
    txtError.Refresh
    
    LogMessage StatusMessage, "Conv2XML Version: v" & CONV2XML_VERSION
    
ExitHandler:
    Exit Sub
    
ErrHandler:
    Resume ExitHandler

End Sub

Public Sub LogMessage(iType As LogMessageType, strMessage As String)
    
    On Error GoTo ErrHandler
    
    Debug.Print strMessage
    
    txtError.Text = txtError.Text & strMessage & vbCrLf
    txtError.SelStart = Len(txtError.Text)
    txtError.Refresh
    
ExitHandler:
    Exit Sub
    
ErrHandler:
    Resume ExitHandler

End Sub


Private Sub cmdClose_Click()
    Unload main
End Sub

Private Sub cmdExecute_Click()
    Dim strControlFile As String
    strControlFile = txtControlFile.Text
    LogMessage StatusMessage, "Control File: " & strControlFile
    
    Dim oControlXML As MSXML2.DOMDocument
    Set oControlXML = LoadXMLFromFile(strControlFile)
    
    Dim oJobs As MSXML2.IXMLDOMNodeList
    Set oJobs = oControlXML.selectNodes("//job")
    Dim oJob As MSXML2.IXMLDOMNode
    For Each oJob In oJobs
        LogMessage StatusMessage, "***Job: " & GetNodeText(oJob, "@name")
        
        Dim strPathRoot As String
        strPathRoot = GetNodeText(oJob, "pathroot")
        LogMessage StatusMessage, "Path Root: " & strPathRoot
        
        Dim strSrc As String
        strSrc = strPathRoot & GetNodeText(oJob, "data/filename")
        
        Dim strConnect As String
        strConnect = GetNodeText(oJob, "data/connect1") & _
                    strSrc & _
                    GetNodeText(oJob, "data/connect2")
        
        Dim strProvider As String
        strProvider = GetNodeText(oJob, "data/provider")
        Dim ds_type As DataSourceType
        ds_type = GetDataSourceType(oJob)
        
        Dim strCommand
        Dim strDest
        Dim strXSLT
        
        Dim oExtracts As MSXML2.IXMLDOMNodeList
        Set oExtracts = oJob.selectNodes("extracts/extract")
        Dim oExtract As MSXML2.IXMLDOMNode
        For Each oExtract In oExtracts
            strDest = strPathRoot & GetNodeText(oExtract, "destfile")
            LogMessage StatusMessage, "Extracting: "
            LogMessage StatusMessage, "   To: " & strDest
            Select Case ds_type
            Case MSWord
                LogMessage StatusMessage, "   Source: " & strSrc
                If InitWordXMLConverter(strSrc, strDest, oExtract) Then
                    ExtractXMLFromWord oExtract
                End If
            Case Else
                LogMessage StatusMessage, "   Provider: " & strProvider
                If strProvider = "" Or strConnect = "" Then
                    Err.Raise 999, "ADO2XML", "No provider or connect specified"
                End If
        
                LogMessage StatusMessage, "   Connect: " & strConnect
                strCommand = GetExtractCommand(ds_type, oExtract)
                LogMessage StatusMessage, "   Command: " & strCommand
                ExtractXMLFromADO strProvider, strConnect, strCommand, strDest
            End Select
        Next oExtract
        
        Dim oTransforms As MSXML2.IXMLDOMNodeList
        Set oTransforms = oJob.selectNodes("processing/transform")
        Dim oTransform As MSXML2.IXMLDOMNode
        For Each oTransform In oTransforms
            strSrc = strPathRoot & GetNodeText(oTransform, "srcfile")
            strXSLT = strPathRoot & GetNodeText(oTransform, "xsltfile")
            strDest = strPathRoot & GetNodeText(oTransform, "destfile")
            
            LogMessage StatusMessage, "Transforming: "
            LogMessage StatusMessage, "   From: " & strSrc
            LogMessage StatusMessage, "   Using: " & strXSLT
            LogMessage StatusMessage, "   To: " & strDest
            
            Dim oParams As MSXML2.IXMLDOMNodeList
            Set oParams = oTransform.selectNodes("params/param")
            If oParams.length = 0 Then
                LogMessage StatusMessage, "   No params"
                ProcessTable strSrc, strXSLT, strDest
            Else
                ' created our params array of strings
                Dim strParams() As String
                ReDim strParams(oParams.length * 2)
                Dim Index As Integer
                Index = 0
                                
                ' pack array from XML control file
                Dim oParam As MSXML2.IXMLDOMNode
                For Each oParam In oParams
                    strParams(Index) = GetNodeText(oParam, "@name")
                    strParams(Index + 1) = oParam.Text
                    LogMessage StatusMessage, "   Param (" & strParams(Index) & "): " & strParams(Index + 1)
                    Index = Index + 2
                Next oParam
                
                ProcessTable strSrc, strXSLT, strDest, strParams
            End If
            
        Next oTransform
        
    Next oJob
    LogMessage StatusMessage, "Done."

End Sub

Private Sub Form_Load()
    txtControlFile.Text = App.Path & "\" & DEFAULT_CONTROLFILE
    ClearLog
End Sub
